From 4b4616ebc5d259c86b88e08b2f44df47fe2ae83e Mon Sep 17 00:00:00 2001
From: tteck <tteckster@gmail.com>
Date: Thu, 12 Aug 2021 11:48:18 -0400
Subject: [PATCH] Add files via upload

---
 pve6_zigbee2mqtt_container.sh | 173 ++++++++++++++++++++++++++++++++++
 pve6_zigbee2mqtt_setup.sh     |  90 ++++++++++++++++++
 2 files changed, 263 insertions(+)
 create mode 100644 pve6_zigbee2mqtt_container.sh
 create mode 100644 pve6_zigbee2mqtt_setup.sh

diff --git a/pve6_zigbee2mqtt_container.sh b/pve6_zigbee2mqtt_container.sh
new file mode 100644
index 00000000..950222f8
--- /dev/null
+++ b/pve6_zigbee2mqtt_container.sh
@@ -0,0 +1,173 @@
+#!/usr/bin/env bash
+
+# Setup script environment
+set -o errexit  #Exit immediately if a pipeline returns a non-zero status
+set -o errtrace #Trap ERR from shell functions, command substitutions, and commands from subshell
+set -o nounset  #Treat unset variables as an error
+set -o pipefail #Pipe will exit with last non-zero status if applicable
+shopt -s expand_aliases
+alias die='EXIT=$? LINE=$LINENO error_exit'
+trap die ERR
+trap cleanup EXIT
+
+function error_exit() {
+  trap - ERR
+  local DEFAULT='Unknown failure occured.'
+  local REASON="\e[97m${1:-$DEFAULT}\e[39m"
+  local FLAG="\e[91m[ERROR] \e[93m$EXIT@$LINE"
+  msg "$FLAG $REASON"
+  [ ! -z ${CTID-} ] && cleanup_ctid
+  exit $EXIT
+}
+function warn() {
+  local REASON="\e[97m$1\e[39m"
+  local FLAG="\e[93m[WARNING]\e[39m"
+  msg "$FLAG $REASON"
+}
+function info() {
+  local REASON="$1"
+  local FLAG="\e[36m[INFO]\e[39m"
+  msg "$FLAG $REASON"
+}
+function msg() {
+  local TEXT="$1"
+  echo -e "$TEXT"
+}
+function cleanup_ctid() {
+  if [ ! -z ${MOUNT+x} ]; then
+    pct unmount $CTID
+  fi
+  if $(pct status $CTID &>/dev/null); then
+    if [ "$(pct status $CTID | awk '{print $2}')" == "running" ]; then
+      pct stop $CTID
+    fi
+    pct destroy $CTID
+  elif [ "$(pvesm list $STORAGE --vmid $CTID)" != "" ]; then
+    pvesm free $ROOTFS
+  fi
+}
+function cleanup() {
+  popd >/dev/null
+  rm -rf $TEMP_DIR
+}
+function load_module() {
+  if ! $(lsmod | grep -Fq $1); then
+    modprobe $1 &>/dev/null || \
+      die "Failed to load '$1' module."
+  fi
+  MODULES_PATH=/etc/modules
+  if ! $(grep -Fxq "$1" $MODULES_PATH); then
+    echo "$1" >> $MODULES_PATH || \
+      die "Failed to add '$1' module to load at boot."
+  fi
+}
+TEMP_DIR=$(mktemp -d)
+pushd $TEMP_DIR >/dev/null
+
+# Download setup script
+wget -qL https://raw.githubusercontent.com/tteck/Proxmox/main/pve6_zigbee2mqtt_setup.sh
+
+# Detect modules and automatically load at boot
+load_module overlay
+
+# Select storage location
+while read -r line; do
+  TAG=$(echo $line | awk '{print $1}')
+  TYPE=$(echo $line | awk '{printf "%-10s", $2}')
+  FREE=$(echo $line | numfmt --field 4-6 --from-unit=K --to=iec --format %.2f | awk '{printf( "%9sB", $6)}')
+  ITEM="  Type: $TYPE Free: $FREE "
+  OFFSET=2
+  if [[ $((${#ITEM} + $OFFSET)) -gt ${MSG_MAX_LENGTH:-} ]]; then
+    MSG_MAX_LENGTH=$((${#ITEM} + $OFFSET))
+  fi
+  STORAGE_MENU+=( "$TAG" "$ITEM" "OFF" )
+done < <(pvesm status -content rootdir | awk 'NR>1')
+if [ $((${#STORAGE_MENU[@]}/3)) -eq 0 ]; then
+  warn "'Container' needs to be selected for at least one storage location."
+  die "Unable to detect valid storage location."
+elif [ $((${#STORAGE_MENU[@]}/3)) -eq 1 ]; then
+  STORAGE=${STORAGE_MENU[0]}
+else
+  while [ -z "${STORAGE:+x}" ]; do
+    STORAGE=$(whiptail --title "Storage Pools" --radiolist \
+    "Which storage pool you would like to use for the container?\n\n" \
+    16 $(($MSG_MAX_LENGTH + 23)) 6 \
+    "${STORAGE_MENU[@]}" 3>&1 1>&2 2>&3) || exit
+  done
+fi
+info "Using '$STORAGE' for storage location."
+
+# Get the next guest VM/LXC ID
+CTID=$(pvesh get /cluster/nextid)
+info "Container ID is $CTID."
+
+# Download latest Debian 10 LXC template
+msg "Updating LXC template list..."
+pveam update >/dev/null
+msg "Downloading LXC template..."
+OSTYPE=debian
+OSVERSION=${OSTYPE}-10
+mapfile -t TEMPLATES < <(pveam available -section system | sed -n "s/.*\($OSVERSION.*\)/\1/p" | sort -t - -k 2 -V)
+TEMPLATE="${TEMPLATES[-1]}"
+pveam download local $TEMPLATE >/dev/null ||
+  die "A problem occured while downloading the LXC template."
+
+# Create variables for container disk
+STORAGE_TYPE=$(pvesm status -storage $STORAGE | awk 'NR>1 {print $2}')
+case $STORAGE_TYPE in
+  dir|nfs)
+    DISK_EXT=".raw"
+    DISK_REF="$CTID/"
+    ;;
+  zfspool)
+    DISK_PREFIX="subvol"
+    DISK_FORMAT="subvol"
+    ;;
+esac
+DISK=${DISK_PREFIX:-vm}-${CTID}-disk-0${DISK_EXT-}
+ROOTFS=${STORAGE}:${DISK_REF-}${DISK}
+
+# Create LXC
+msg "Creating LXC container..."
+DISK_SIZE=2G
+pvesm alloc $STORAGE $CTID $DISK $DISK_SIZE --format ${DISK_FORMAT:-raw} >/dev/null
+if [ "$STORAGE_TYPE" == "zfspool" ]; then
+  warn "Some containers may not work properly due to ZFS not supporting 'fallocate'."
+else
+  mkfs.ext4 $(pvesm path $ROOTFS) &>/dev/null
+fi
+ARCH=$(dpkg --print-architecture)
+HOSTNAME=zigbee2mqtt
+TEMPLATE_STRING="local:vztmpl/${TEMPLATE}"
+pct create $CTID $TEMPLATE_STRING -arch $ARCH -features nesting=1 \
+  -hostname $HOSTNAME -net0 name=eth0,bridge=vmbr0,ip=dhcp -onboot 1 \
+  -ostype $OSTYPE -rootfs $ROOTFS,size=$DISK_SIZE -storage $STORAGE >/dev/null
+
+# Modify LXC permissions to support Zigbee Sticks
+LXC_CONFIG=/etc/pve/lxc/${CTID}.conf
+cat <<EOF >> $LXC_CONFIG
+lxc.cgroup.devices.allow: c 188:* rwm
+lxc.mount.entry: /dev/serial/by-id               dev/serial/by-id         none bind,optional,create=dir
+lxc.mount.entry: /dev/ttyUSB0                    dev/ttyUSB0             none bind,optional,create=file
+lxc.mount.entry: /dev/ttyACM0                    dev/ttyACM0             none bind,optional,create=file
+EOF
+
+# Set container timezone to match host
+MOUNT=$(pct mount $CTID | cut -d"'" -f 2)
+ln -fs $(readlink /etc/localtime) ${MOUNT}/etc/localtime
+pct unmount $CTID && unset MOUNT
+
+# Setup container
+msg "Starting LXC container..."
+pct start $CTID
+pct push $CTID pve6_zigbee2mqtt_setup.sh /pve6_zigbee2mqtt_setup.sh -perms 755
+pct exec $CTID /pve6_zigbee2mqtt_setup.sh
+
+# Get network details and show completion message
+IP=$(pct exec $CTID ip a s dev eth0 | sed -n '/inet / s/\// /p' | awk '{print $2}')
+info "Successfully created zigbee2mqtt LXC Container to $CTID at IP Address ${IP}"
+echo
+echo -e "\e[1;31m Update of configuration.yaml is required and found at /opt/zigbee2mqtt/data/ \e[0m"
+echo
+echo -e "Z2M can be started after completing the configuration buy running \e[1;33m sudo systemctl start zigbee2mqtt \e[0m"
+echo
diff --git a/pve6_zigbee2mqtt_setup.sh b/pve6_zigbee2mqtt_setup.sh
new file mode 100644
index 00000000..86b46ed9
--- /dev/null
+++ b/pve6_zigbee2mqtt_setup.sh
@@ -0,0 +1,90 @@
+#!/usr/bin/env bash
+
+# Setup script environment
+set -o errexit  #Exit immediately if a pipeline returns a non-zero status
+set -o errtrace #Trap ERR from shell functions, command substitutions, and commands from subshell
+set -o nounset  #Treat unset variables as an error
+set -o pipefail #Pipe will exit with last non-zero status if applicable
+shopt -s expand_aliases
+alias die='EXIT=$? LINE=$LINENO error_exit'
+trap die ERR
+trap 'die "Script interrupted."' INT
+
+function error_exit() {
+  trap - ERR
+  local DEFAULT='Unknown failure occured.'
+  local REASON="\e[97m${1:-$DEFAULT}\e[39m"
+  local FLAG="\e[91m[ERROR:LXC] \e[93m$EXIT@$LINE"
+  msg "$FLAG $REASON"
+  exit $EXIT
+}
+function msg() {
+  local TEXT="$1"
+  echo -e "$TEXT"
+}
+
+# Prepare container OS
+msg "Setting up Container OS..."
+sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
+locale-gen >/dev/null
+apt-get -y purge openssh-{client,server} >/dev/null
+apt-get autoremove >/dev/null
+
+# Update container OS
+msg "Updating Container OS..."
+apt-get update >/dev/null
+apt-get -qqy upgrade &>/dev/null
+
+# Install prerequisites
+msg "Installing Prerequisites..."
+apt-get -qqy install \
+    curl \
+    sudo &>/dev/null
+    # Setup Node.js repository
+    msg "Setting up Node.js Repository..."
+    sudo curl -sL https://deb.nodesource.com/setup_14.x | sudo -E bash - &>/dev/null
+    # Install Node.js;
+    msg "Installing Node.js..."
+    sudo apt-get install -y nodejs git make g++ gcc &>/dev/null
+    # Clone Zigbee2MQTT repository
+    msg "Setting up Zigbee2MQTT Repository..."
+    sudo git clone https://github.com/Koenkk/zigbee2mqtt.git /opt/zigbee2mqtt &>/dev/null
+    # Install zigbee2mqtt
+    msg "Installing Zigbee2MQTT..."
+    cd /opt/zigbee2mqtt &>/dev/null
+    npm ci --production &>/dev/null
+
+echo "Creating service file zigbee2mqtt.service"
+service_path="/etc/systemd/system/zigbee2mqtt.service"
+
+echo "[Unit]
+Description=zigbee2mqtt
+After=network.target
+[Service]
+ExecStart=/usr/bin/npm start
+WorkingDirectory=/opt/zigbee2mqtt
+StandardOutput=inherit
+StandardError=inherit
+Restart=always
+User=root
+[Install]
+WantedBy=multi-user.target" > $service_path
+
+# Customize container
+msg "Customizing Container..."
+rm /etc/motd # Remove message of the day after login
+rm /etc/update-motd.d/10-uname # Remove kernel information after login
+touch ~/.hushlogin # Remove 'Last login: ' and mail notification after login
+GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
+mkdir -p $(dirname $GETTY_OVERRIDE)
+cat << EOF > $GETTY_OVERRIDE
+[Service]
+ExecStart=
+ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
+EOF
+systemctl daemon-reload
+systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
+
+# Cleanup container
+msg "Cleanup..."
+rm -rf /pve6_zigbee2mqtt_setup.sh /var/{cache,log}/* /var/lib/apt/lists/*
\ No newline at end of file